#pragma once

#include "ofMain.h"
#include "ofxNetwork.h"
#include "ofxOpenCv.h"
#include "ofxARToolkitPlus.h""
#include "ofxGui.h"
#include "ofxCvHaarFinder.h"

class testApp : public ofBaseApp{

	public:

		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);

		ofVideoPlayer 		roverMovie;
		bool                stopPlay;

		ofxTCPClient        tcpClient;

        /* Size of the image */
		int width, height, ofw, ofh;

		/* ARToolKitPlus class */
		ofxARToolkitPlus artk;
		int threshold;

		/* OpenCV images */
		ofxCvColorImage colorImage;
		ofxCvGrayscaleImage grayImage, grayImageFace;
		ofxCvGrayscaleImage	grayThres;

        // Rover + PanTilt
        void roverMarker(int ind);

        int frameLoss;
        int markerID;
		int posLR, posUD;
		bool scanL, scanR;
		bool scanLR, foundM0, cameraM0, roverM0;
		bool roverMID0, roverMID1, roverMID2, roverMID3, roverMID4, roverMID5;

        float diag;
		ofPoint center;
		vector<ofPoint> corners;

        // GUI
        void moveAroundToggled(bool &moveA);
        void faceDetectToggled(bool &faceD);
        void findMarkerToggled(bool &findM);
        void thresChanged(int &thr);
        void panChanged(int &pan);
        void tiltChanged(int &tilt);

		bool bHide;

        ofxToggle moveAround;
        ofxToggle faceDetect;
        ofxToggle findMarker;
        ofxIntSlider thres;
        ofxToggle drawThres;
        ofxIntSlider pan;
        ofxIntSlider tilt;

        ofxPanel gui;

        // Face Detect
        ofxCvHaarFinder finder;

        // Texture
        ofImage img0, img1, img2, img3, img4, img5, imgRing;

        ofLight light;
        ofMesh meshRing;

        ofTrueTypeFont myfont;
};

